/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2011, 2019 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_cg_adc_user.c
* Version      : CodeGenerator for RL78/G14 V2.05.04.02 [20 Nov 2019]
* Device(s)    : R5F104ML
* Tool-Chain   : CCRL
* Description  : This file implements device driver for ADC module.
* Creation Date: 
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_adc.h"
/* Start user code for include. Do not edit comment generated here */
#include "r_cg_dtc.h"
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
#pragma interrupt r_adc_interrupt(vect=INTAD)
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */

#define ADC_ADM0_COMMON (_00_AD_CONVERSION_CLOCK_64 | _00_AD_TIME_MODE_NORMAL_1 | _00_AD_OPERMODE_SELECT | _01_AD_COMPARATOR_ENABLE)
#define ADC_ADM0_CONVERSION_ENABLE  (_80_AD_CONVERSION_ENABLE)
#define ADC_ADM0_CONVERSION_DISABLE (_00_AD_CONVERSION_DISABLE)

ad_channel_t g_adc_ads[ADC_CH_LIST_NUM + 1] = 
{
#if ADC_CH_LIST_NUM >= 1
    ADC_CH_LIST_00,
#endif
#if ADC_CH_LIST_NUM >= 2
    ADC_CH_LIST_01,
#endif
#if ADC_CH_LIST_NUM >= 3
    ADC_CH_LIST_02,
#endif
#if ADC_CH_LIST_NUM >= 4
    ADC_CH_LIST_03,
#endif
#if ADC_CH_LIST_NUM >= 5
    ADC_CH_LIST_04,
#endif
#if ADC_CH_LIST_NUM >= 6
    ADC_CH_LIST_05,
#endif
#if ADC_CH_LIST_NUM >= 7
    ADC_CH_LIST_06,
#endif
#if ADC_CH_LIST_NUM >= 8
    ADC_CH_LIST_07,
#endif
#if ADC_CH_LIST_NUM >= 9
    ADC_CH_LIST_08,
#endif
#if ADC_CH_LIST_NUM >= 10
    ADC_CH_LIST_09,
#endif
#if ADC_CH_LIST_NUM >= 11
    ADC_CH_LIST_10,
#endif
#if ADC_CH_LIST_NUM >= 12
    ADC_CH_LIST_11,
#endif
#if ADC_CH_LIST_NUM >= 13
    ADC_CH_LIST_12,
#endif
#if ADC_CH_LIST_NUM >= 14
    ADC_CH_LIST_13,
#endif
#if ADC_CH_LIST_NUM >= 15
    ADC_CH_LIST_14,
#endif
#if ADC_CH_LIST_NUM >= 16
    ADC_CH_LIST_15,
#endif
#if ADC_CH_LIST_NUM >= 17
    ADC_CH_LIST_16,
#endif
#if ADC_CH_LIST_NUM >= 18
    ADC_CH_LIST_17,
#endif
#if ADC_CH_LIST_NUM >= 19
    ADC_CH_LIST_18,
#endif
    ADINTERREFVOLT /* dummy */
};
uint8_t g_adc_adm0[ADC_CH_LIST_NUM + 1] = 
{
#if ADC_CH_LIST_NUM >= 1
    ADC_ADM0_COMMON | ADC_ADM0_CONVERSION_ENABLE,
#endif
#if ADC_CH_LIST_NUM >= 2
    ADC_ADM0_COMMON | ADC_ADM0_CONVERSION_ENABLE,
#endif
#if ADC_CH_LIST_NUM >= 3
    ADC_ADM0_COMMON | ADC_ADM0_CONVERSION_ENABLE,
#endif
#if ADC_CH_LIST_NUM >= 4
    ADC_ADM0_COMMON | ADC_ADM0_CONVERSION_ENABLE,
#endif
#if ADC_CH_LIST_NUM >= 5
    ADC_ADM0_COMMON | ADC_ADM0_CONVERSION_ENABLE,
#endif
#if ADC_CH_LIST_NUM >= 6
    ADC_ADM0_COMMON | ADC_ADM0_CONVERSION_ENABLE,
#endif
#if ADC_CH_LIST_NUM >= 7
    ADC_ADM0_COMMON | ADC_ADM0_CONVERSION_ENABLE,
#endif
#if ADC_CH_LIST_NUM >= 8
    ADC_ADM0_COMMON | ADC_ADM0_CONVERSION_ENABLE,
#endif
#if ADC_CH_LIST_NUM >= 9
    ADC_ADM0_COMMON | ADC_ADM0_CONVERSION_ENABLE,
#endif
#if ADC_CH_LIST_NUM >= 10
    ADC_ADM0_COMMON | ADC_ADM0_CONVERSION_ENABLE,
#endif
#if ADC_CH_LIST_NUM >= 11
    ADC_ADM0_COMMON | ADC_ADM0_CONVERSION_ENABLE,
#endif
#if ADC_CH_LIST_NUM >= 12
    ADC_ADM0_COMMON | ADC_ADM0_CONVERSION_ENABLE,
#endif
#if ADC_CH_LIST_NUM >= 13
    ADC_ADM0_COMMON | ADC_ADM0_CONVERSION_ENABLE,
#endif
#if ADC_CH_LIST_NUM >= 14
    ADC_ADM0_COMMON | ADC_ADM0_CONVERSION_ENABLE,
#endif
#if ADC_CH_LIST_NUM >= 15
    ADC_ADM0_COMMON | ADC_ADM0_CONVERSION_ENABLE,
#endif
#if ADC_CH_LIST_NUM >= 16
    ADC_ADM0_COMMON | ADC_ADM0_CONVERSION_ENABLE,
#endif
#if ADC_CH_LIST_NUM >= 17
    ADC_ADM0_COMMON | ADC_ADM0_CONVERSION_ENABLE,
#endif
#if ADC_CH_LIST_NUM >= 18
    ADC_ADM0_COMMON | ADC_ADM0_CONVERSION_ENABLE,
#endif
#if ADC_CH_LIST_NUM >= 19
    ADC_ADM0_COMMON | ADC_ADM0_CONVERSION_ENABLE,
#endif
    ADC_ADM0_COMMON | ADC_ADM0_CONVERSION_DISABLE
};
volatile uint16_t g_adc_adcr[ADC_CH_LIST_NUM]; /* +1 is not necessary */

volatile uint8_t g_adc_ready_flag = 0;

/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
* Function Name: r_adc_interrupt
* Description  : This function is INTAD interrupt service routine.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
static void __near r_adc_interrupt(void)
{
    /* Start user code. Do not edit comment generated here */

    U_DTCD0_Start(); /* enable A/D converter DTC */
    U_DTCD3_Start(); /* enable TAU0 Channel0 DTC */

    g_adc_ready_flag = 1;

    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */

/***********************************************************************************************************************
* Function Name: U_ADC_Interrupt_Enable
* Description  : This function enables INTAD interrupt.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void U_ADC_Interrupt_Enable(void)
{
    ADMK = 0U;  /* enable INTAD interrupt */
}

/* End user code. Do not edit comment generated here */
